function problem1aDriver
%seek local minimization using steepest gradient descent approach
format short
close all;
clear all;
clc;

%intial guess
x_k=[2;1];
x0=x_k;

%plot contour plot of rosenbrock's function
%analytical min (sol)
xMin=[0,1];
interval=2;
x=linspace(-interval+xMin(1),interval+xMin(1),100);
y=linspace(-interval+xMin(2),interval+xMin(2),100);
[xx,yy]=meshgrid(x,y);

%evaluate function
xeval=xx(:)';
yeval=yy(:)';
[f,grad]=rosenbrock_function([xeval;yeval]);
fM=reshape(f,100,100);
%gradM=reshape(grad,100,100);

%plot Rosenbrock's function
figure(1)
contour(xx,yy,fM,'linewidth',2)
xlabel('x')
ylabel('y')
hold on

%plot global minimum
plot(1,1,'g*')

%find minimum using gradient descent with linear search
stepSize=1;
tol=10^-8;
%x_k=[0;1];

options=optimset('Algorithm','sqp','gradObj','on');
iter=0;

X(:,1)=x_k; %for plotting

%method of steepest descent
while iter<2000 && stepSize>tol 
    %evaluate local gradient
    [localf,s_k]=rosenbrock_function(x_k);
    
    %normalize gradient
    s_k=-s_k/norm(s_k);

    %form linear constraint equation
    A=[s_k(2) s_k(1)];
    b=(A*x_k);
    
    %linear extrapolation
    [x_min,f_min,exitflag,output]  =fmincon(@rosenbrock_function,x_k,[],[],A,b,[],[],[],options);
    
    %stepSize
    stepSize=norm(x_min-x_k);
    x_k=x_min;
    
    %to see how close our approximation is to true solution
    val=rosenbrock_function(x_k)

    iter=iter+1; %update number of iteration
    X(:,iter+1)=x_k;
    Step(iter)=stepSize;
end

%plot path and show number of iteration
format long
title(['final stepsize is ' num2str(stepSize) ' with ' num2str(iter) ' iterations'])
plot(X(1,:),X(2,:),'r-')
[nr,nc]=size(X);
h=plot(X(1,1:nc/20:nc),X(2,1:nc/20:nc),'ro');
legend(h,['[' num2str(x0(1)) ','  num2str(x0(2)) ']'])

figure(2)
loglog(1:length(Step),Step,'ro-')
hold on
legend(['[' num2str(x0(1)) ','  num2str(x0(2)) ']'])
title('stepsize versus iterations')
    