function problem1cDriver
%seek local minimization using BFGS approach
format short
close all;
clear all;
clc;

%intial guess
x_k=[-1;1];
x0=x_k;

%plot contour plot of rosenbrock's function
%analytical min (sol)
xMin=[0,1];
interval=3;
x=linspace(-interval+xMin(1),interval+xMin(1),100);
y=linspace(-interval+xMin(2),interval+xMin(2),100);
[xx,yy]=meshgrid(x,y);

%evaluate function
xeval=xx(:)';
yeval=yy(:)';
[f,grad]=rosenbrock_function([xeval;yeval]);
fM=reshape(f,100,100);
%gradM=reshape(grad,100,100);

%plot Rosenbrock's function
figure(1)
contour(xx,yy,fM,20,'linewidth',2)
xlabel('x')
ylabel('y')
hold on

%plot global minimum
plot(1,1,'g*','linewidth',10)

%find minimum using BFGS
stepSize=1;
tol=10^-8;
iter=0;

X(:,1)=x_k; %for plotting

B=eye(2);
%method of BFGS
while iter<2000 && stepSize>tol 
    %evaluate local gradient
    [f,gradf]=rosenbrock_function(x_k);
    s_k=B\(-gradf);
    x_k=x_k+s_k;
    
    [fnew,gradfnew]=rosenbrock_function(x_k);
    y_k=gradfnew-gradf;
    
    
    %update B
    dB=y_k*y_k'/(y_k'*s_k)-B*s_k*s_k'*B/(s_k'*B*s_k);
    B=B+dB;
    
    stepSize=norm(s_k);

    iter=iter+1; %update number of iteration
    X(:,iter+1)=x_k;
    Step(iter)=stepSize;
    error(iter)=abs(fnew);
end

%plot path and show number of iteration
format long
title(['final stepsize is ' num2str(stepSize) ' with ' num2str(iter) ' iterations'])
plot(X(1,:),X(2,:),'r-')
[nr,nc]=size(X)
if nc>20
   h=plot(X(1,1:nc/20:nc),X(2,1:nc/20:nc),'ro')
else
   h=plot(X(1,:),X(2,:),'ro') 
end
legend(h,['[' num2str(x0(1)) ','  num2str(x0(2)) ']'])

figure(2)
loglog(1:length(Step),Step,'ro-')
%loglog(1:length(error),error,'ro-')
hold on
legend(['[' num2str(x0(1)) ','  num2str(x0(2)) ']'])
title('stepsize versus iterations')